/*
 * Copyright 1994 by OpenVision Technologies, Inc.
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appears in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of OpenVision not be used
 * in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission. OpenVision makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 * 
 * OPENVISION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL OPENVISION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * $Id: gss-misc.h,v 1.4 1997/10/01 21:39:53 meeroh Exp $
 */

#ifndef _GSSMISC_H_
#define _GSSMISC_H_

#ifndef macintosh
#	include <gssapi/gssapi_generic.h>
#else
#	include <gssapi_generic.h>
#endif
#include <stdio.h>

int send_token
	PROTOTYPE( (int s, gss_buffer_t tok) );
int recv_token
	PROTOTYPE( (int s, gss_buffer_t tok) );
void display_status
	PROTOTYPE( (FILE *log, char *msg, OM_uint32 maj_stat,
		    OM_uint32 min_stat) );

int recv_sealed_token
	PROTOTYPE( (int s, gss_ctx_id_t context, gss_buffer_t tok,
		    int *conf_state, OM_uint32 *maj_stat,
		    OM_uint32 *min_stat) );

int send_sealed_token
	PROTOTYPE( (int s, gss_ctx_id_t context, gss_buffer_t tok,
		    int *conf_state, OM_uint32 *maj_stat,
		    OM_uint32 *min_stat) );

int create_kludge_token
	PROTOTYPE ((char *username, char *password, gss_buffer_desc *token));

int parse_kludge_token
	PROTOTYPE ((char **username, char **pasword, gss_buffer_desc *token));

#endif
