/*
 * hmac_md5.c --- Do "Hugo's MAC" for MD5
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "hmac_md5.h"

void HMAC_MD5_SetKey(struct HMAC_MD5_Context *context, unsigned char *key,
		     int key_len)
{
        MD5_CTX 	ctx;
	unsigned char	keybuf[64];
	int		i;

	if (key_len > 64) {
                MD5Init(&ctx);
                MD5Update(&ctx, key, key_len);
                MD5Final(keybuf, &ctx);
		memset(keybuf+16, 0, 48);
        } else {
		memcpy(keybuf, key, key_len);
		memset(keybuf+key_len, 0, 64 - key_len);
	}

	/* Calculate the inner pad */
        for (i=0; i<64; i++)
                keybuf[i] ^= 0x36;
	MD5Init(&ctx);
	MD5Update(&ctx, keybuf, 64);
	memcpy(context->ibuf, ctx.buf, 16);

	/* Calculate the outer pad */
        for (i=0; i<64; i++)
                keybuf[i] ^= (0x36 ^ 0x5c);
	MD5Init(&ctx);
	MD5Update(&ctx, keybuf, 64);
	memcpy(context->obuf, ctx.buf, 16);
}

void HMAC_MD5(struct HMAC_MD5_Context *context, 
	      unsigned char *data, int data_len,
	      unsigned char digest[16])
{
        MD5_CTX 	ctx;

	memcpy(ctx.buf, context->ibuf, 16);
	ctx.bits[0] = 512; ctx.bits[1] = 0;

        MD5Update(&ctx, data, data_len); /* then text of datagram */
        MD5Final(digest, &ctx);          /* finish up 1st pass */
	
	memcpy(ctx.buf, context->obuf, 16);
	ctx.bits[0] = 512; ctx.bits[1] = 0;

        MD5Update(&ctx, digest, 16);     /* then results of 1st hash */
        MD5Final(digest, &ctx);          /* finish up 2nd pass */
}
