
WHAT=windows

all:: all-$(WHAT)
clean:: clean-$(WHAT)
install:: install-$(WHAT)
check:: check-$(WHAT)

all-windows::
clean-windows::
install-windows::
check-windows::

# Directory syntax:
R=\		# root
C=.\		# current
S=\		# seperator
U=..\		# up one level

srcdir = .
SRCTOP = $(srcdir)\$(BUILDTOP)

# /* The name of the C compiler for the target */
CC=cl /nologo
CL=
#
# CCOPTS for DLL functions
#
##WIN16##CCOPTS=/ALw /Zp /GD2s /Os /Zi /Od /W3 /Ld $(XTRA) /DKLUDGE_DLL_FILE
CCOPTS=/Os /Zi /Od /W3 /MD $(XTRA) -DKLUDGE_DLL_FILE
#
# CCOPTS for non-DLL compiles
#
##WIN16##CCOPTS2=/AL /Zp /GA /G2s  /Os /Zi /Od /W3 $(XTRA)
CCOPTS2=/Os /Zi /Od /W3 $(XTRA)
CPPFLAGS =  -I$(SRCTOP)\include -I$(SRCTOP)\include\krb5 -DLEHMAN
DEFS = $(CPPFLAGS)
CFLAGS2 = $(CCOPTS2) $(DEFS)

# /Zi gives debug info in each object file.
# /Zp packs structures: Required for Windows API (but is not default!!!)
# /Za strict ansi compliance
# /ALw memory model:  Large model for Windows DLL (SS != DS)
# /GD DLL code generation for Windows 3.0 and up, and defines _WINDOWS
# /Gs Avoid stack probes (they don't seem to work anyway)
# /Os optimize for space.  FIXME:  Do not use /Ox; it miscompiles the DES lib!
# /G2 generate 286 instructions (it complains if you ask for 386!)
# /Od disable optimization (for debugging)
# /MD (Win32) thread safe, ML would be single threaded, don't build with ML

DBG_LIB=/nologo /Zp /ALw /GD /Gs /Os /G2 /Zi /Od
# /Zi gives debug info in each object file.
# /Zp packs structures: Required for Windows API (but is not default!!!)
# /AL large memory model
# /Mq quickwin ascii stdio window, and defines _WINDOWS
DBG=/nologo /Zp /AL /Os /Mq /Zi /Od

RM=$(BUILDTOP)\config\rm.bat
LIBECHO=$(BUILDTOP)\util\windows\libecho
CP=copy
MV=ren
LN=copy
LIBCMD=lib
PAGESIZE=/pagesize:128
AWK=rem
RC = rc
CVTRES = cvtres

##WIN16##CLIB=$(BUILDTOP)\lib\comerr16.lib
CLIB=$(BUILDTOP)\lib\comerr32.lib
##WIN16##KLIB=$(BUILDTOP)\lib\krb5_16.lib
KLIB=$(BUILDTOP)\lib\krb5_32.lib
##WIN16##GLIB=$(BUILDTOP)\lib\gssapi.lib
GLIB=$(BUILDTOP)\lib\gssapi32.lib
##WIN16##K4LIB=$(BUILDTOP)\lib\krb4_16.lib
K4LIB=$(BUILDTOP)\lib\krb4_32.lib
##WIN16##WLIB=$(BUILDTOP)\lib\winsock.lib
WLIB=

ARADD=rem
RANLIB=rem
ARCHIVE=rem

LIBEXT=lib
OBJEXT=obj
EXEEXT=.exe

MFLAGS=$(MAKEFLAGS)

#
# End of Microsoft Windows config lines
#

# makefile: Constructs the Kerberos for Windows ticket manager
#
OBJS 	 = test-kludge.obj 
XOBJS	= resource.obj

##### Options
DEBUG 	 = 1
BUILDTOP = \tytso\krb5-nt
INCLUDES = /I$(BUILDTOP)\include /I$(BUILDTOP)\include\krb5

##### C Compiler
!if $(DEBUG)
CFLAGS 	 = $(CCOPTS2) $(INCLUDES) /Zi
!else
CFLAGS 	 = $(CCOPTS2) $(INCLUDES)
!endif

CFLAGS_DLL = $(CCOPTS) $(INCLUDES)

##### RC Compiler
RFLAGS 	 = $(INCLUDES)


##### Linker
LINK 	 = link
LIBS 	 = $(GLIB) $(CLIB) $(WLIB)
SYSLIBS  = kernel32.lib wsock32.lib user32.lib gdi32.lib comdlg32.lib
!if $(DEBUG)
LFLAGS = /nologo /debug
!else
LFLAGS = /nologo
!endif

all:: kludge.exe

kludge.exe: $(OBJS) $(XOBJS) $(LIBS) kludge.lib
	$(LINK) $(LFLAGS) /map:$*.map /out:$@ $(OBJS) $(XOBJS) \
	  kludge.lib $(LIBS) $(SYSLIBS)

kludge.res: kludge.rc
	$(RC) $(RFLAGS) -D_WIN32 -DGSS_APP /r $*.rc

resource.obj: kludge.res
	$(CVTRES) /nologo /out:$@ kludge.res

install::
	copy gss.exe ..\floppy

clean:: 
	if exist *.exe del *.exe
	if exist ..\floppy\gss.exe del ..\floppy\gss.exe
	if exist *.obj del *.obj
	if exist *.res del *.res
	if exist *.map del *.map
	if exist *.pdb del *.pdb
	if exist *.err del *.err

#
# For the DLL
#

WINDLLFLAGS = /incremental:no /pdb:none /debug \
		/nologo /align:0x1000 /base:0x1c000000 /dll \
		/entry:DllMain

gss-client.obj: gss-client.c
	$(CC) $(CFLAGS_DLL) /c gss-client.c

gss-misc.obj: gss-misc.c
	$(CC) $(CFLAGS_DLL) /c gss-misc.c

win_glue.obj: win_glue.c
	$(CC) $(CFLAGS_DLL) /c win_glue.c

kludge.lib: gss-client.obj gss-misc.obj win_glue.obj
	link $(WINDLLFLAGS) /def:kludge.def /out:kludge.dll \
		gss-client.obj gss-misc.obj win_glue.obj $(LIBS) $(SYSLIBS)

# config/post.in
# put all:: first just in case no other rules occur here
#
all::

.c.obj:
	$(CC) $(CFLAGS) /c $*.c
!if defined(LIBNAME)
##WIN16##	$(LIBCMD) $(PAGESIZE) /nologo $(LIBNAME) -+$@;

!if !defined(OBJFILELIST)
OBJFILELIST=@$(OBJFILE)
!endif
!if !defined(OBJFILEDEP)
OBJFILEDEP=$(OBJFILE)
!endif

all-windows:: $(LIBNAME)
$(LIBNAME): $(OBJFILEDEP)
	$(LIBCMD) /out:$(LIBNAME) /nologo $(OBJFILELIST)
!endif


!if defined(OBJFILE)
all-windows:: $(OBJFILE)
clean-windows::
	$(RM) $(OBJFILE)
!if defined(LIBOBJS)
$(OBJFILE): $(LIBOBJS)
	$(RM) $(OBJFILE)
##WIN16##	$(CP) nul: $(OBJFILE)
!if defined(PREFIXDIR)
	$(LIBECHO) -p $(PREFIXDIR)\ $** > $(OBJFILE)
!else
	$(LIBECHO) $** > $(OBJFILE)
!endif
!endif
!endif


check::
check-windows::

.depend: $(SRCS) $(SRCTOP)/util/depfix.sed
	if test -n "$(SRCS)" ; then \
		$(CC) -M $(CFLAGS) $(SRCS) | \
			sed -f $(SRCTOP)/util/depfix.sed | \
			sed -e 's; $(SRCTOP)/; $$(SRCTOP)/;g' | \
			sed -e 's; $(srcdir)/; $$(srcdir)/;g' | \
			sed -e 's; $(BUILDTOP)/; $$(BUILDTOP)/;g' | \
			sed -e 's; \./; ;g' > .depend; \
	else :; fi

depend:: .depend
	if test -n "$(SRCS)" ; then \
		sed -e '/^# +++ Dependency line eater +++/,$$d' \
			< $(srcdir)/Makefile.in | cat - .depend \
			> $(srcdir)/Makefile.in.new; \
	$(MV) $(srcdir)/Makefile.in $(srcdir)/Makefile.in.old; \
	$(MV) $(srcdir)/Makefile.in.new $(srcdir)/Makefile.in; \
	else :; fi

clean:: clean-$(WHAT)
	$(RM) config.log pre.out post.out Makefile.out

clean-unix::
	if test -n "$(OBJS)" ; then $(RM) $(OBJS); else :; fi
	$(RM) .depend

clean-windows::
	$(RM) *.$(OBJEXT)
	$(RM) msvc.pdb *.err *.exe *.bak

!if defined(LIBNAME)
clean-windows::
	$(RM) $(LIBNAME)
!endif
!if defined(OBJFILE)
clean-windows::
	$(RM) $(OBJFILE)
!endif
