
#include <stdio.h>
#include "oracle_int.h"

main(int argc, char **argv)
{
  	char *err, *username, *password;

	if (Oracle_Init(0, 0, &err)) {
		printf("Oracle init failed: %s\n", err);
		exit(1);
	}
	if (argc < 3) {
		fprintf(stderr, "Usage: %s username password\n", argv[0]);
		exit(1);
	}
	username = argv[1];
	password = argv[2];
	printf("Setting %s's password to be %s.\n", username, password);
	if (Oracle_SetPassword(username, password, &err)) {
		fprintf(stderr, "Error setting password: %s\n", err);
		exit(1);
	}
	if (Oracle_Shutdown(&err)) {
		fprintf(stderr, "Error shutting down oracle connection: %s\n",
			err);
		exit(1);
	}
	exit(0);
}
